#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

import wx

############################################################################
##                                                                        ##
##                       Module de conversion                             ##
##                            Version 0.1                                 ##
##                                                                        ##
##                                                                        ##
##                                                                        ##
############################################################################

#class Convers(wx.App):
    #"""Application principale"""
    #def OnInit(self):
        ## cration de la fentre principale
        #frame = ModuleConv("Module de conversion %s" %version) 
        
        ## insertion de l'icone de l'application 
        #icon = wx.Icon("favicon.png", wx.BITMAP_TYPE_PNG)
        #frame.SetIcon(icon)
        
        #frame.Show(True)
        ##self.SetTopWindow(frame)
        #return True
    
    
    
class ModuleConv(wx.Frame):
    """Module de conversion"""
    
    
    def __init__(self, parent):
        version = 'Conversions 0.1'
        wx.Frame.__init__(self, parent, -1, title = version, pos=(40,40), 
                          style=wx.DEFAULT_FRAME_STYLE ^(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))
        
        
        ############## Cration du panel #########################
        
        panel =  wx.Panel(self, -1, style = wx.TAB_TRAVERSAL
                     | wx.CLIP_CHILDREN
                     | wx.FULL_REPAINT_ON_RESIZE
                     )
        
        ############## cration du sizer principal ###############
        
        self.gbs = wx.GridBagSizer(hgap=5, vgap=5)
        
        ############## Cration de statusbar #####################
        
        self.CreateStatusBar()
        self.SetStatusText("Entrez une valeur puis cliquez sur convertir")
        
        ############## cration des widgets #####################
        
        # Choix de la tension
        self.listetension = [u'240V monophas', u'400V triphas cosPhi = 0.8']
        self.tension = wx.RadioBox(panel, -1, u" Tension d'emploi ", 
                                   (-1, -1), wx.DefaultSize, self.listetension, 1, 
                                   style = wx.RA_SPECIFY_COLS)
        
        # Choix du type de conversion
        self.listeConversion = [u'Intensit (A)', u'Puissance (W)', u'Chevaux (CV)']
        self.Conversion = wx.RadioBox(panel, -1, u"Unit  convertir ", 
                                      (-1,-1), wx.DefaultSize, self.listeConversion, 1, 
                                      style = wx.RA_SPECIFY_COLS)
        self.Bind(wx.EVT_RADIOBOX, self.onChoixUnite, self.Conversion)
        
        # Choix de la valeur  convertir
        #labelValeur = wx.StaticText(panel, -1, u'Valeur  convertir :')
        self.Valeur = wx.SpinCtrl(panel, -1, "", (150,-1), (80,-1))
        self.Valeur.SetRange(1,650)
        self.Valeur.SetValue(100)
        
        # bouton "convertir" (par dfaut)
        self.btnConv = wx.Button(panel, -1, "Convertir")
        self.btnConv.SetBackgroundColour('yellow')
        
        self.btnConv.SetDefault()
        self.Bind(wx.EVT_BUTTON, self.onConvertir, self.btnConv)
        
        
        # fentre des rsultats
        labelResult = wx.StaticText(panel, -1, u"Rsultats :")
        self.Result1 = wx.StaticText(panel, -1, '...', (-1,-1), (120,-1), wx.ALIGN_LEFT)
        self.Result1.SetForegroundColour('blue')
        self.Result1.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        self.unite1 = wx.StaticText(panel, -1, 'W')
        self.unite1.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        self.Result2 = wx.StaticText(panel, -1, '...')
        self.Result2.SetForegroundColour('blue')
        self.Result2.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        self.unite2 = wx.StaticText(panel, -1, 'CV')
        self.unite2.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        
        # bouton "quitter"
        self.btnQuit = wx.Button(panel, -1, "Quitter")
        self.Bind(wx.EVT_BUTTON, self.onQuitter, self.btnQuit)
        
        ############### Ajout des wigets au sizer ####################
        
        self.gbs.Add(self.tension, (1,1), (1,2), wx.EXPAND)
        self.gbs.Add(self.Valeur, (3,0))
        self.gbs.Add(self.Conversion, pos=(2,1), span=(2,2), flag=wx.EXPAND)
        self.gbs.Add(self.btnConv, (5,0))
        self.gbs.Add(labelResult, (7,0))
        self.gbs.Add(self.Result1, (7,1))
        self.gbs.Add(self.unite1, (7,2))
        self.gbs.Add(self.Result2, (8,1))
        self.gbs.Add(self.unite2, (8,2))
        self.gbs.Add(self.btnQuit, (9,2))
        
        panel.SetSizerAndFit(self.gbs)
        self.SetClientSize(panel.GetSize())
        
       
        
    def onChoixUnite(self, evt):
        """Choisit les units  convertir """
        
        # permet de fixer les valeurs du spinctrl
        def setValeur(range1, range2, value, label1, label2):
            self.Valeur.SetRange(range1, range2)
            self.Valeur.SetValue(value)
            self.unite1.SetLabel(label1)
            self.unite2.SetLabel(label2)
        
        # Permet de choisir les unit converties de sortie
        unite = self.Conversion.GetStringSelection()
        # de CV  A & W
        if unite == self.listeConversion[2]:
            setValeur(1, 489, 10, 'A', 'W')
        # de W  CV & A
        elif unite == self.listeConversion[1]: 
            setValeur(1,360000,5000,'A','CV')
        # de A  W & CV
        else :
            setValeur(1,650,100,'W','CV')
        
    
    
    
    
    def onConvertir(self, evt):
        #Choix de la tension et du coef (cos phi x sqr(3) ou 1)
        if self.tension.GetStringSelection() == self.listetension[0]:
            U = 240.
            coef = 1.
        else :
            U = 400.
            coef = 1.38564
        # import de la valeur
        val = self.Valeur.GetValue()
        
        if self.Conversion.GetStringSelection() == self.listeConversion[2]:
            # conv CV->A et CV->W
            i = round(((val*735.5)/(U*coef)), 2)
            self.Result1.SetLabel('%s' %i)
            p = round(val*735.5, 2)
            self.Result2.SetLabel('%s' %p)
                      
        elif self.Conversion.GetStringSelection() == self.listeConversion[1]:
            # conv W->A et W->CV
            i = round((val/(U*coef)), 2)
            self.Result1.SetLabel('%s' %i)
            cv = round((val/735.5), 2)
            self.Result2.SetLabel('%s' %cv)
        else :
            # conv A->W et A->CV
            p = round((U*val*coef), 2)
            self.Result1.SetLabel('%s' %p)
            cv = round(((U*val*coef)/735.5), 2)
            self.Result2.SetLabel('%s' %cv)
    
    
    
    
    def onQuitter(self, evt):
        """Quitter l'application"""
        self.Destroy()
    

#if __name__ == "__main__":
    #app = Convers()
    #app.MainLoop()
