#!usr/bin/python
#-*- coding: iso-8859-15 -*-

import wx
import wx.html
from wx.lib.wordwrap import wordwrap

version = "0.2"
try :
    f = open('licence.txt', 'r')
    licenseText = f.read()
    f.close()
except :
    licenseText = (
        u'Logiciel sous licence GPL2.\n'
        u'Le fichier "licence.txt" qui contient la licence GPL2 est manquant !'
        )

   
class Cable(wx.App):
    def OnInit(self):
        # cration de la fentre principale
        frame = Principale("pyElec %s" % version) 
        frame.Show(True)
        self.SetTopWindow(frame)
        return True

class Aide(wx.Frame):
    def __init__(self, parent, title):
        wx.Frame.__init__(self, parent, -1, title, size=(600,400))
        html = wx.html.HtmlWindow(self)
        if "gtk2" in wx.PlatformInfo:
            html.SetStandardFonts()
        html.LoadFile("help.html")
       
    def onClose(self, event):
        self.Destroy()
    
    
    
class Principale(wx.Frame):
    
    def __init__(self, titre):
        wx.Frame.__init__(self, None, -1, title = titre, size=(600,400))
        #self.SetMinSize(self.GetSize())
        self.SetBackgroundColour('green')
        
        ############## cration du panneau principal ######################
        panel = wx.Panel(self, -1, size = (600,400))
        panel.SetBackgroundColour('yellow')
        
        #################CRATION DES MENUS #######################
        # Menu Cable
        menuCable = wx.Menu()
        
        menuCableNouveau = menuCable.Append(wx.ID_NEW, u"Nouveau calcul", u"Nouveau calcul")
        self.Bind(wx.EVT_MENU, self.onCalcul, menuCableNouveau)
        
        menuCable.AppendSeparator()
        
        menuCableQuitter = menuCable.Append(wx.ID_EXIT, "Quitter", "Quitter")
        self.Bind(wx.EVT_MENU, self.onQuitter, menuCableQuitter)
        
        # Menu Aide 
        menuAide = wx.Menu()
        menuAideAide = menuAide.Append(wx.ID_HELP,'Aide')
        self.Bind(wx.EVT_MENU, self.onAide, menuAideAide)
        menuAideApropos = menuAide.Append(wx.ID_ABOUT,'A propos...')
        self.Bind(wx.EVT_MENU, self.onApropos, menuAideApropos)
        
        barreMenu = wx.MenuBar()        
        barreMenu.Append(menuCable, u"&Cbles") 
        barreMenu.Append(menuAide, "&Aide")
        
        self.SetMenuBar(barreMenu)
        
        ############## Cration de statusbar #####################
        
        self.CreateStatusBar()
        
        ############## Cration des widgets ######################
        
        # choix des mtaux (metal)
        liste1 = ['Cuivre', 'Aluminium']
        self.metal = wx.RadioBox(panel, -1, u' Type de cble ', (-1, -1), wx.DefaultSize, 
                    liste1, 1, style = wx.RA_SPECIFY_COLS)
        self.Bind(wx.EVT_RADIOBOX, self.onCalcul, self.metal)
        
        # Choix tension (tension)R
        liste2 = [u'240V monophas', u'400V triphas cos Phi = 0,8']
        self.tension = wx.RadioBox(panel, -1, u' Tension ', (10, 10), wx.DefaultSize,
                    liste2, 1, wx.RA_SPECIFY_COLS)
        self.Bind(wx.EVT_RADIOBOX, self.onCalcul, self.tension)
        
        # Chute de tension (chute)
        self.labelChute = wx.StaticText(panel, -1, 'Chute de tension (en %) :')
        self.chute = wx.SpinCtrl(self, -1, '')
        self.chute.SetRange(1,10)
        self.chute.SetValue(3)
        
        # Saisie de la longueur de cable (lg)
        self.labelLg = wx.StaticText(panel, -1, u'Longueur du cble (en mtres) :')
        self.lg = wx.SpinCtrl(self, -1, '')
        self.lg.SetRange(1, 500)
        self.lg.SetValue(100)
        
        # Saisie de l'intensit (intensite)
        self.labelI = wx.StaticText(panel, -1, u'Intensit (en Ampres) :')    
        self.intensite = wx.SpinCtrl(self, -1, "", (30, 50))
        self.intensite.SetRange(1,300)
        self.intensite.SetValue(50)
        
        # Bouton calculer (par dfaut)
        self.btnCalc = wx.Button(panel, -1, "Calculer")
        self.Bind(wx.EVT_BUTTON, self.onCalcul, self.btnCalc)
        self.btnCalc.SetDefault()
        
        # Fentre des rsultats
        self.labelResult = wx.StaticText(panel, -1, u"Section calcule :", style=wx.ALIGN_RIGHT)
        self.Result = wx.StaticText(panel, -1, '...')
        self.Result.SetForegroundColour('red')
        self.Result.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD))
        
        # bouton Quitter
        self.btnQuit = wx.Button(panel, -1, "Quitter")
        self.Bind(wx.EVT_BUTTON, self.onQuitter, self.btnQuit)
       
        
        
        ############### Ajout des wigets au sizer ####################
        
        sizer = wx.GridBagSizer(hgap=5, vgap=5)
        sizer.Add(self.metal, (0, 0))
        sizer.Add(self.tension, (0, 1))
        sizer.Add(self.labelChute, (1, 0))
        sizer.Add(self.chute, (1, 1))
        sizer.Add(self.labelI, (2, 0))
        sizer.Add(self.intensite, (2, 1))
        sizer.Add(self.labelLg, (3,0))
        sizer.Add(self.lg, (3,1))
        sizer.Add(self.btnCalc, (4,3))
        sizer.Add(self.labelResult, (6,0))
        sizer.Add(self.Result, (6,1))
        sizer.Add(self.btnQuit, (8,3))
        
        panel.SetSizer(sizer)
        panel.Fit() #ajuste la taille du sizer
        
        
        print sizer.GetMinSize()
        self.SetMinSize(sizer.GetMinSize())
        
        sizer.Add((15,15), (11,3))

        panel.SetSizerAndFit(sizer)
        
        self.SetClientSize(panel.GetSize())
        self.SetMinSize(sizer.GetMinSize())
        self.SetMaxSize(panel.GetSize())
        
            
    def onCalcul(self, evt):

        # choix de ro selon le type de cble
        m = self.metal.GetStringSelection()
        if m == 'Cuivre':
            ro = 23
        else : 
            ro = 37
        print 'ro =%s' %ro
        
        # choix de la chute de tension en %
        deltau = self.chute.GetValue()
        if deltau == 0:
            deltau = 3
        print u'chute de tension=%s pourcents' %deltau
        
        # choix de la chute de tension en Volts, du coef b, de lbda
        v = self.tension.GetStringSelection()
        if v == u'240V monophas':
            u = deltau*2400
            b = 2
            lbda = 0.13
            cosphi = 1
            sinphi = 0
        else :         
            u = deltau*2400
            b = 1
            lbda = 0.08
            cosphi = 0.8
            sinphi = 0.6
        print 'chute de tension %s mV' %u
        print 'coef b =%s' %b
        print 'coef lambda =%s' %lbda
        print 'cosphi = %s, sinphi = %s' %(cosphi, sinphi)
                
        # choix intensit
        i = self.intensite.GetValue()
        if i == 0:
            i = 50
        print 'i = %s A' %i
        
        # choix longueur de cble
        l = self.lg.GetValue()
        if l == 0:
            l = 100
        print 'longueur = %s m' %l
             
        # calcul de la section s
        s = (ro*l*cosphi)/((u/(b*i))-(lbda*l*sinphi))
        s = round (s, 2)
        print 'Section = %s mm2' %s
        self.Result.SetLabel('%s mm2' %s)

    
    def onQuitter(self, evt):
        """Quitter l'application"""
        self.Destroy()

    def onAide(self, evt):
        self.dlg = Aide(self, "Aide" )
        self.dlg.Show(True)
        
    def onApropos(self, evt):
        #wx.MessageBox(u'Fonction "A propos..." non implmente', 'A propos...')
        info = wx.AboutDialogInfo()
        info.Name = "pyElec" 
        info.Version = "%s" % version
        info.Copyright = u"Logiciel distibu sous licence GPL"
        info.Description = wordwrap(
            u"pyElec permet de calculer une section de cble en fonction de :\n"
            u"- la longueur du cble\n"
            u"- l'intensit\n"
            u"- le type de conducteur\n"
            u"- la chute de tension\n"
            u"\nCe programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier "
            u"au titre des clauses de la Licence Publique Gnrale GNU"
            u"; soit la version 2 de la Licence, ou "
            u"une version ultrieure quelconque. \nCe programme est distribu dans l'espoir qu'il sera "
            u"utile, mais SANS AUCUNE GARANTIE ; sans mme une garantie implicite de COMMERCIABILITE ou "
            u"DE CONFORMITE A UNE UTILISATION PARTICULIERE. Voir la Licence Publique Gnrale GNU pour "
            u"plus de dtails (fichier \"licence.txt\")"
            u"\n\nPour tout contact, visiter le site ci-dessous",
            350, wx.ClientDC(self))
        info.WebSite = ("http://www.pycave.tuxfamily.org/")
        info.Developers = [ u"Stphan GURIN",
                            "...",
                            "..." ]

        #info.License = wordwrap(licenseText, 500, wx.ClientDC(self))
        info.Licence = licenseText

        # Then we call wx.AboutBox giving it that info object
        wx.AboutBox(info)
    
    
if __name__ == "__main__":
    app = Cable()
    app.MainLoop()