#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

import wx
import wx.html
from wx.lib.wordwrap import wordwrap
import os

version = "0.3"

try :
    f = open('licence.txt', 'r')
    licenseText = f.read()
    f.close()
except :
    licenseText = (
        u'Ce logiciel est distribu sous licence GPL2.\n'
        u'\nLe fichier "licence.txt" qui contient la licence est manquant !'
        )

def opj(path):
    """Convert paths to the platform-specific separator"""
    st = apply(os.path.join, tuple(path.split('/')))
    # HACK: on Linux, a leading / gets lost...
    if path.startswith('/'):
        st = '/' + st
    return st

class Cable(wx.App):
    """Application principame"""
    def OnInit(self):
        # cration de la fentre principale
        frame = Principale("pyElec %s" % version) 
        frame.Show(True)
        self.SetTopWindow(frame)
        return True

class Aide(wx.Frame):
    """Aide au format html"""
    def __init__(self, parent, title):
        wx.Frame.__init__(self, parent, -1, title, size=(800,600))
        html = wx.html.HtmlWindow(self)
        if "gtk2" in wx.PlatformInfo:
            html.SetStandardFonts()
            
        html.LoadFile("help.html")
       
    def onClose(self, event):
        self.Destroy()
    
class Principale(wx.Frame):
    """Calcul des sections de cble"""
    def __init__(self, titre):
        wx.Frame.__init__(self, None, -1, title = titre,
                      style=wx.DEFAULT_FRAME_STYLE ^(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))
        
        ############## Cration du panel #########################
        
        panel =  wx.Panel(self, -1, style = wx.TAB_TRAVERSAL
                     | wx.CLIP_CHILDREN
                     | wx.FULL_REPAINT_ON_RESIZE
                     )
        panel.SetBackgroundColour('white')        
        
        ############## cration du sizer principal ###############
        
        self.gbs = wx.GridBagSizer(hgap=5, vgap=5)
        
        ############## Cration de statusbar #####################
        
        self.CreateStatusBar()
        self.SetStatusText("Aide contextuelle...")
        
        #################CRATION DES MENUS #######################
        
        barreMenu = wx.MenuBar()
        
        # Menu Cable
        menuCable = wx.Menu()
        
        menuCableNouveau = menuCable.Append(wx.ID_NEW, u"Nouveau calcul", u"Lancer le calcul")
        self.Bind(wx.EVT_MENU, self.onCalcul, menuCableNouveau)
        
        menuCable.AppendSeparator()
        
        menuCableQuitter = menuCable.Append(wx.ID_EXIT, "Quitter", "Quitter l'application...")
        self.Bind(wx.EVT_MENU, self.onQuitter, menuCableQuitter)
        
        # Menu Aide 
        menuAide = wx.Menu()
        menuAideAide = menuAide.Append(wx.ID_HELP,'Aide', u"Aide sur le logiciel")
        self.Bind(wx.EVT_MENU, self.onAide, menuAideAide)
        menuAideApropos = menuAide.Append(wx.ID_ABOUT,'A propos...', u"A propos de ce logiciel...")
        self.Bind(wx.EVT_MENU, self.onApropos, menuAideApropos)
                
        barreMenu.Append(menuCable, u"&Cbles") 
        barreMenu.Append(menuAide, "&Aide")
        
        self.SetMenuBar(barreMenu)
        
        ############## Cration des widgets ######################
        
        # choix des mtaux
        liste1 = ['Cuivre', 'Aluminium']
        self.metal = wx.RadioBox(panel, -1, u' Type de cble ', (-1, -1), wx.DefaultSize, 
                    liste1, 1, style = wx.RA_SPECIFY_COLS)
        self.metal.SetToolTipString(u'Choix du mtal des conducteurs')
        self.Bind(wx.EVT_RADIOBOX, self.onCalcul, self.metal)
        
        # Choix tension
        liste2 = [u'240V monophas', u'400V triphas cos Phi = 0,8']
        self.tension = wx.RadioBox(panel, -1, u' Tension ', (10, 10), wx.DefaultSize,
                    liste2, 1, wx.RA_SPECIFY_COLS)
        self.tension.SetToolTipString(u"Choix de la tension d'alimentation")
        self.Bind(wx.EVT_RADIOBOX, self.onCalcul, self.tension)
        
        # Chute de tension
        self.labelChute = wx.StaticText(panel, -1, 'Chute de tension (en %) :')
        self.chute = wx.SpinCtrl(panel, -1, "", size=(50,-1))
        self.chute.SetRange(3,8)
        self.Bind(wx.EVT_SPINCTRL, self.onCalcul, self.chute)
        
        # Saisie de la longueur de cable
        self.labelLg = wx.StaticText(panel, -1, u'Longueur du cble (en mtres) :')
        self.lg = wx.SpinCtrl(panel, -1, "", size=(50,-1))
        self.lg.SetRange(1, 999)
        self.lg.SetValue(100)
        self.Bind(wx.EVT_SPINCTRL, self.onCalcul, self.lg)
        
        # Saisie de l'intensit
        self.labelI = wx.StaticText(panel, -1, u'Intensit (en Ampres) :')    
        self.intensite = wx.SpinCtrl(panel, -1, "", size=(50,-1))
        self.intensite.SetRange(1,500)
        self.intensite.SetValue(50)
        self.Bind(wx.EVT_SPINCTRL, self.onCalcul, self.intensite)
        
        # Bouton calculer (par dfaut)
        self.btnCalc = wx.Button(panel, -1, "Calculer")
        self.btnCalc.SetToolTipString("Lancer le calcul...")
        self.Bind(wx.EVT_BUTTON, self.onCalcul, self.btnCalc)
        self.btnCalc.SetDefault()
        
        # Fentre des rsultats
        self.labelResult = wx.StaticText(panel, -1, u"Section calcule :", style=wx.ALIGN_RIGHT)
        self.Result = wx.StaticText(panel, -1, '...')
        self.Result.SetForegroundColour('red')
        self.Result.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        
        # bouton Quitter
        self.btnQuit = wx.Button(panel, -1, "Quitter")
        self.btnQuit.SetToolTipString("Quitter l'application...")
        self.Bind(wx.EVT_BUTTON, self.onQuitter, self.btnQuit)
        
        # logo
        #pos = 100
        #img = wx.Image(opj('pic14018.jpg'), wx.BITMAP_TYPE_JPEG).ConvertToBitmap()
        #pos = pos + img.GetHeight() + 10
        #self.logo = wx.StaticBitmap(panel, -1, img, (10, pos), (img.GetWidth(), img.GetHeight()))
        
        ############### Ajout des wigets au sizer ####################
        
        self.gbs.Add(self.metal, (0, 0))
        self.gbs.Add(self.tension, (0, 1))
        self.gbs.Add(self.labelChute, (1, 0))
        self.gbs.Add(self.chute, (1, 1))
        self.gbs.Add(self.labelI, (2, 0))
        self.gbs.Add(self.intensite, (2, 1))
        self.gbs.Add(self.labelLg, (3,0))
        self.gbs.Add(self.lg, (3,1))
        self.gbs.Add(self.btnCalc, (4,3))
        self.gbs.Add(self.labelResult, (6,0))
        self.gbs.Add(self.Result, (6,1))
        self.gbs.Add(self.btnQuit, (8,3))
        #self.gbs.Add(self.logo, (8,0))        
        
        panel.SetSizerAndFit(self.gbs)
        self.SetClientSize(panel.GetSize())
        
        self.Centre() # centre la fentre  l'ouverture sur l'cran
    
    def onCalcul(self, evt):
        
        # choix de ro selon le type de cble
        m = self.metal.GetStringSelection()
        if m == 'Cuivre':
            ro = 23
        else : 
            ro = 37
        
        # choix de la chute de tension en %
        deltau = self.chute.GetValue()
        if deltau == 0:
            deltau = 3
        
        # choix de la chute de tension en Volts, du coef b, de lbda
        v = self.tension.GetStringSelection()
        if v == u'240V monophas':
            u = deltau*2400
            b = 2
            lbda = 0.13
            cosphi = 1
            sinphi = 0
        else :         
            u = deltau*2400
            b = 1
            lbda = 0.08
            cosphi = 0.8
            sinphi = 0.6
                
        # choix intensit
        i = self.intensite.GetValue()
        if i == 0:
            i = 50
        
        # choix longueur de cble
        l = self.lg.GetValue()
        if l == 0:
            l = 100
             
        # calcul de la section s
        s = (ro*l*cosphi)/((u/(b*i))-(lbda*l*sinphi))
        s = round (s, 2)
        
        if s >= 631 or s < 0 :
            self.Result.SetLabel('section incalculable')
        else :
            self.Result.SetLabel('%s mm2' %s)
    
    def onQuitter(self, evt):
        """Quitter l'application"""
        self.Destroy()

    def onAide(self, evt):
        self.dlg = Aide(self, "Aide" )
        self.dlg.Show(True)
    
    def onApropos(self, evt):
        #wx.MessageBox(u'Fonction "A propos..." non implmente', 'A propos...')
        info = wx.AboutDialogInfo()
        info.Name = "pyElec" 
        info.Version = "%s" % version
        info.Copyright = u"Logiciel distibu sous licence GPL"
        info.Description = wordwrap(
            u"pyElec permet de calculer une section de cble en fonction de :\n"
            u"- la longueur du cble\n"
            u"- l'intensit\n"
            u"- le type de conducteur\n"
            u"- la chute de tension\n"
            u"\nCe programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier "
            u"au titre des clauses de la Licence Publique Gnrale GNU"
            u"; soit la version 2 de la Licence, ou "
            u"une version ultrieure quelconque. \nCe programme est distribu dans l'espoir qu'il sera "
            u"utile, mais SANS AUCUNE GARANTIE ; sans mme une garantie implicite de COMMERCIABILITE ou "
            u"DE CONFORMITE A UNE UTILISATION PARTICULIERE. Voir la Licence Publique Gnrale GNU pour "
            u"plus de dtails (fichier \"licence.txt\")"
            u"\n\nPour tout contact, visiter le site ci-dessous",
            350, wx.ClientDC(self))
        info.WebSite = ("http://www.pycave.tuxfamily.org/")
        info.Developers = [ u"Stphan GURIN",
                            "...",
                            "..." ]
        #info.License = wordwrap(licenseText, 500, wx.ClientDC(self))
        info.Licence = licenseText
        wx.AboutBox(info)    

if __name__ == "__main__":
    app = Cable()
    app.MainLoop()
