#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

import wx
import wx.html
from wx.lib.wordwrap import wordwrap
import os

version = "0.4b"

############################################################################
##                                                                        ##
##   Changements                                                          ##
##                                                                        ##
##   version 0.4a                                                         ##
##   - section mini normalise en alu descendue  25mm2 (fait)            ##
##   - changer le rpertoire de travail par celui ou est install pyElec  ##
##     pour simplifier le script d'innosetup                              ##
##     (fait mais  tester sous windows)                                  ##                                                                        ##
##                                                                        ##
##   version 0.4b                                                         ##
##   - ajout d'un module conversion Ampres -> Watts -> Chevaux           ##
##   - fermer TOUTES les fentres lors de la fermeture de la fentre      ##
##     principale (fait)                                                  ##
##                                                                        ##
##                                                                        ##
############################################################################

sectCu = ' 1.5 2.5 4 6 10 16 25  35 50 70 95 120 150 185 240 300 400 500 630'.split()
sectAlu = '25 35 50 70 95 120 150 185 240 300 400 630'.split()

try :
    f = open('licence.txt', 'r')
    licenseText = f.read()
    f.close()
except :
    licenseText = (
        u'Ce logiciel est distribu sous licence GPL2.\n'
        u'\nLe fichier "licence.txt" qui contient la licence est manquant !'
        )






# conversion du rpertoire courant en rpertoire de travail
def changeDir():
    path = os.getcwd()
    os.chdir(path)



# Conversion des chemins en fonction de l'OS
def opj(path):
    """Convert paths to the platform-specific separator"""
    st = apply(os.path.join, tuple(path.split('/')))
    # HACK: on Linux, a leading / gets lost...
    if path.startswith('/'):
        st = '/' + st
    return st





class Cable(wx.App):
    """Application principale"""
    def OnInit(self):
        # cration de la fentre principale
        frame = Principale("pyElec %s" % version) 
        
        # insertion de l'icone de l'application 
        icon = wx.Icon("favicon.png", wx.BITMAP_TYPE_PNG)
        frame.SetIcon(icon)
        
        frame.Show(True)
        self.SetTopWindow(frame)
        return True






class Aide(wx.Frame):
    """Aide au format html"""
    def __init__(self, parent, title):
        wx.Frame.__init__(self, parent, -1, title, size=(800,600))
        html = wx.html.HtmlWindow(self)
        if "gtk2" in wx.PlatformInfo:
            html.SetStandardFonts()
            
        html.LoadFile("help.html")
       
    def onClose(self, event):
        self.Destroy()
        





class Conversion(wx.Frame):
    """ conversion Ampres / Watts / Chevaux"""
    def __init__(self, parent, titre):
        wx.Frame.__init__(self, parent, -1, title = titre, 
                      style=wx.DEFAULT_FRAME_STYLE ^(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))
        
        ############## Cration du panel #########################
        
        panel =  wx.Panel(self, -1, style = wx.TAB_TRAVERSAL
                     | wx.CLIP_CHILDREN
                     | wx.FULL_REPAINT_ON_RESIZE
                     )
        panel.SetBackgroundColour('grey')  
        
        ############## cration du sizer principal ###############
        
        self.gbs = wx.GridBagSizer(hgap=5, vgap=5)
        
        ############## Cration de statusbar #####################
        
        self.CreateStatusBar()
        self.SetStatusText("Entrez une valeur puis cliquez sur convertir")
        
        ############## cration des widgets #####################
        
        # Choix de la tension
        self.listetension = [u'240V monophas', u'400V triphas']
        self.tension = wx.RadioBox(panel, -1, u" Tension d'emploi ", 
                                   (-1, -1), wx.DefaultSize, self.listetension, 1, 
                                   style = wx.RA_SPECIFY_COLS)
        
        # Choix du type de conversion
        self.listeConversion = [u'Intensit (A)', u'Puissance (W)', u'Chevaux (CV)']
        self.Conversion = wx.RadioBox(panel, -1, u"Unit  convertir ", 
                                      (-1,-1), wx.DefaultSize, self.listeConversion, 1, 
                                      style = wx.RA_SPECIFY_COLS)
        self.Bind(wx.EVT_RADIOBOX, self.onChoixUnite, self.Conversion)
        
        # Choix de la valeur  convertir
        #labelValeur = wx.StaticText(panel, -1, u'Valeur  convertir :')
        self.Valeur = wx.SpinCtrl(panel, -1, "", (150,-1), (80,-1))
        self.Valeur.SetRange(1,650)
        self.Valeur.SetValue(100)
        
        # bouton "convertir" (par dfaut)
        self.btnConv = wx.Button(panel, -1, "Convertir")
        self.btnConv.SetBackgroundColour('yellow')

        self.btnConv.SetDefault()
        self.Bind(wx.EVT_BUTTON, self.onConvertir, self.btnConv)
        
        
        # fentre des rsultats
        labelResult = wx.StaticText(panel, -1, u"Rsultats :")
        self.Result1 = wx.StaticText(panel, -1, '...', (-1,-1), (120,-1), wx.ALIGN_LEFT)
        self.Result1.SetForegroundColour('blue')
        self.Result1.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        self.unite1 = wx.StaticText(panel, -1, 'W')
        self.unite1.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        self.Result2 = wx.StaticText(panel, -1, '...')
        self.Result2.SetForegroundColour('blue')
        self.Result2.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        self.unite2 = wx.StaticText(panel, -1, 'CV')
        self.unite2.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        
        # bouton "quitter"
        self.btnQuit = wx.Button(panel, -1, "Quitter")
        self.Bind(wx.EVT_BUTTON, self.onQuitter, self.btnQuit)
        
        ############### Ajout des wigets au sizer ####################
        
        self.gbs.Add(self.tension, (1,1), (1,2), wx.EXPAND)
        self.gbs.Add(self.Valeur, (3,0))
        self.gbs.Add(self.Conversion, pos=(2,1), span=(2,2), flag=wx.EXPAND)
        self.gbs.Add(self.btnConv, (5,0))
        self.gbs.Add(labelResult, (7,0))
        self.gbs.Add(self.Result1, (7,1))
        self.gbs.Add(self.unite1, (7,2))
        self.gbs.Add(self.Result2, (8,1))
        self.gbs.Add(self.unite2, (8,2))
        self.gbs.Add(self.btnQuit, (9,2))
        
        self.gbs.InsertSpacer(0,0)
        
        panel.SetSizerAndFit(self.gbs)
        self.SetClientSize(panel.GetSize())
        
    def onChoixUnite(self, evt):
        """Choisit les units  convertir """
        
        # permet de fixer les valeurs du spinctrl
        def setValeur(range1, range2, value, label1, label2):
            self.Valeur.SetRange(range1, range2)
            self.Valeur.SetValue(value)
            self.unite1.SetLabel(label1)
            self.unite2.SetLabel(label2)
        
        # Permet de choisir les unit converties de sortie
        unite = self.Conversion.GetStringSelection()
        # de CV  A & W
        if unite == self.listeConversion[2]:
            setValeur(1, 489, 10, 'A', 'W')
        # de W  CV & A
        elif unite == self.listeConversion[1]: 
            setValeur(1,360000,5000,'A','CV')
        # de A  W & CV
        else :
            setValeur(1,650,100,'W','CV')
        
    
    def onConvertir(self, evt):
        #Choix de la tension et du coef (cos phi x sqr(3) ou 1)
        if self.tension.GetStringSelection() == self.listetension[0]:
            U = 240.
            coef = 1.
        else :
            U = 400.
            coef = 1.38564
        # import de la valeur
        val = self.Valeur.GetValue()
        
        if self.Conversion.GetStringSelection() == self.listeConversion[2]:
            # conv CV->A et CV->W
            i = round(((val*735.5)/(U*coef)), 2)
            self.Result1.SetLabel('%s' %i)
            p = round(val*735.5, 2)
            self.Result2.SetLabel('%s' %p)
                      
        elif self.Conversion.GetStringSelection() == self.listeConversion[1]:
            # conv W->A et W->CV
            i = round((val/(U*coef)), 2)
            self.Result1.SetLabel('%s' %i)
            cv = round((val/735.5), 2)
            self.Result2.SetLabel('%s' %cv)
        else :
            # conv A->W et A->CV
            p = round((U*val*coef), 2)
            self.Result1.SetLabel('%s' %p)
            cv = round(((U*val*coef)/735.5), 2)
            self.Result2.SetLabel('%s' %cv)
    
    def onQuitter(self, evt):
        """Quitter l'application"""
        self.Destroy()







    
class Principale(wx.Frame):
    """Calcul des sections de cble"""
    def __init__(self, titre):
        wx.Frame.__init__(self, None, -1, title = titre,
                      style=wx.DEFAULT_FRAME_STYLE ^(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))
        
        ############## Cration du panel #########################
        
        panel =  wx.Panel(self, -1, style = wx.TAB_TRAVERSAL
                     | wx.CLIP_CHILDREN
                     | wx.FULL_REPAINT_ON_RESIZE
                     )
        panel.SetBackgroundColour('white')        
        
        ############## cration du sizer principal ###############
        
        self.gbs = wx.GridBagSizer(hgap=5, vgap=5)
        
        ############## Cration de statusbar #####################
        
        self.CreateStatusBar()
        self.SetStatusText("Consultez l'aide pour plus d'infos...")
        
        #################CRATION DES MENUS #######################
        
        barreMenu = wx.MenuBar()
        
        # Menu Cable
        menuCable = wx.Menu()
        
        menuCableConversion = menuCable.Append(wx.ID_APPLY, u"Conversions", u"Conversions Watts / Ampres / Chevaux")
        self.Bind(wx.EVT_MENU, self.onConversion, menuCableConversion)
        
        menuCable.AppendSeparator()
        
        menuCableQuitter = menuCable.Append(wx.ID_EXIT, "Quitter", "Quitter l'application...")
        self.Bind(wx.EVT_MENU, self.onQuitter, menuCableQuitter)
        
        # Menu Aide 
        menuAide = wx.Menu()
        menuAideAide = menuAide.Append(wx.ID_HELP,'Aide', u"Aide sur le logiciel")
        self.Bind(wx.EVT_MENU, self.onAide, menuAideAide)
        menuAideApropos = menuAide.Append(wx.ID_ABOUT,'A propos...', u"A propos de ce logiciel...")
        self.Bind(wx.EVT_MENU, self.onApropos, menuAideApropos)
                
        barreMenu.Append(menuCable, u"&Modules") 
        barreMenu.Append(menuAide, "&Aide")
        
        self.SetMenuBar(barreMenu)
        
        ############## Cration des widgets ######################
        
        # choix des mtaux
        liste1 = ['Cuivre', 'Aluminium']
        self.metal = wx.RadioBox(panel, -1, u' Type de cble ', (-1, -1), wx.DefaultSize, 
                    liste1, 1, style = wx.RA_SPECIFY_COLS)
        self.metal.SetToolTipString(u'Choix du mtal des conducteurs')
        self.Bind(wx.EVT_RADIOBOX, self.onCalcul, self.metal)
        
        # Choix tension
        liste2 = [u'240V monophas', u'400V triphas cos Phi = 0,8']
        self.tension = wx.RadioBox(panel, -1, u' Tension ', (-1, -1), wx.DefaultSize,
                    liste2, 1, wx.RA_SPECIFY_COLS)
        self.tension.SetToolTipString(u"Choix de la tension d'alimentation")
        self.Bind(wx.EVT_RADIOBOX, self.onChute, self.tension)
        
        # Chute de tension
        self.labelChute = wx.StaticText(panel, -1, 'Chute de tension (en %) :')
        self.chute = wx.SpinCtrl(panel, -1, "", size=(50,-1))
        self.chute.SetRange(3,8)
        self.Bind(wx.EVT_SPINCTRL, self.onCalcul, self.chute)
        
        # Saisie de la longueur de cable
        self.labelLg = wx.StaticText(panel, -1, u'Longueur du cble (en mtres) :')
        self.lg = wx.SpinCtrl(panel, -1, "", size=(50,-1))
        self.lg.SetRange(1, 999)
        self.lg.SetValue(100)
        self.Bind(wx.EVT_SPINCTRL, self.onCalcul, self.lg)
        
        # Saisie de l'intensit
        self.labelI = wx.StaticText(panel, -1, u'Intensit (en Ampres) :')    
        self.intensite = wx.SpinCtrl(panel, -1, "", size=(50,-1))
        self.intensite.SetRange(1,650)
        self.intensite.SetValue(50)
        self.Bind(wx.EVT_SPINCTRL, self.onCalcul, self.intensite)
        
        # Fentre des rsultats
        self.labelResult = wx.StaticText(panel, -1, u"Section calcule :", style=wx.ALIGN_RIGHT)
        self.Result = wx.StaticText(panel, -1, '... mm2')
        self.Result.SetForegroundColour('red')
        self.Result.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        
        # Fentre sections prconises
        self.labelPreco = wx.StaticText(panel, -1, u"Section normalise :", style=wx.ALIGN_RIGHT)
        self.preco = wx.StaticText(panel, -1, '... mm2')
        self.preco.SetForegroundColour('blue')
        self.preco.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        
        # bouton Quitter
        self.btnQuit = wx.Button(panel, -1, "Quitter")
        self.btnQuit.SetToolTipString("Quitter l'application...")
        self.Bind(wx.EVT_BUTTON, self.onQuitter, self.btnQuit)
        
        # logo de l'application
        pos = 100
        img = wx.Image(opj('logo.png'), wx.BITMAP_TYPE_PNG).ConvertToBitmap()
        pos = pos + img.GetHeight() + 10
        self.logo = wx.StaticBitmap(panel, -1, img, (10, pos), (img.GetWidth(), img.GetHeight()))
        
        ############### Ajout des wigets au sizer ####################
        
        self.gbs.Add(self.metal, (0, 0))
        self.gbs.Add(self.tension, (0, 1))
        self.gbs.Add(self.labelChute, (1, 0))
        self.gbs.Add(self.chute, (1, 1))
        self.gbs.Add(self.labelI, (2, 0))
        self.gbs.Add(self.intensite, (2, 1))
        self.gbs.Add(self.labelLg, (3,0))
        self.gbs.Add(self.lg, (3,1))
        self.gbs.Add(self.labelResult, (6,0))
        self.gbs.Add(self.Result, (6,1))
        self.gbs.Add(self.labelPreco, (7,0))
        self.gbs.Add(self.preco, (7,1))
        self.gbs.Add(self.btnQuit, (8,3))
        self.gbs.Add(self.logo, (8,0))        
        
        panel.SetSizerAndFit(self.gbs)
        self.SetClientSize(panel.GetSize())
        
        self.Centre() # centre la fentre  l'ouverture sur l'cran
        
    # Changement du rpertoire courant par le rpertoire ou est install pyElec
    changeDir()

    def onChute(self, evt):
        tens = self.tension.GetStringSelection()
        if tens == u'240V monophas':
            self.chute.SetValue(3)
        else :
            self.chute.SetValue(5)
        self.onCalcul(evt)
        
    def onCalcul(self, evt):
        
        # choix de ro selon le type de cble
        m = self.metal.GetStringSelection()
        if m == 'Cuivre':
            ro = 23
            sect = sectCu
        else : 
            ro = 37
            sect = sectAlu
        
        # choix de la chute de tension en %
        deltau = self.chute.GetValue()
        if deltau == 0:
            deltau = 3
        
        # choix de la chute de tension en Volts, du coef b, de lbda
        v = self.tension.GetStringSelection()
        if v == u'240V monophas':
            u = deltau*2400
            b = 2
            lbda = 0.13
            cosphi = 1
            sinphi = 0
        else :         
            u = deltau*2400
            b = 1
            lbda = 0.08
            cosphi = 0.8
            sinphi = 0.6
                
        # choix intensit
        i = self.intensite.GetValue()
        if i == 0:
            i = 50
        
        # choix longueur de cble
        l = self.lg.GetValue()
        if l == 0:
            l = 100
             
        # calcul de la section s
        s = (ro*l*cosphi)/((u/(b*i))-(lbda*l*sinphi))
        s = round (s, 2)
        
        if s >= 631 or s < 0 :
            self.Result.SetLabel(u'section non calcule')
            self.preco.SetLabel(u'section non dfinie')
        else :
            # affiche la section calcule
            self.Result.SetLabel('%s mm2' %s)
            # choix de la section normalise
            a = 0            
            sectPreco = sect[a]
            for sectNorm in sect :
                if float(sectNorm) < s:
                    sectPreco = sect[a+1]
                a += 1
            # affiche la section normalise surieure  la section calcule
            self.preco.SetLabel('%s mm2' %sectPreco)
    
    def onConversion(self, evt):
        #wx.MessageBox(u"Ce module ne fonctionne pas encore !", 'Erreur !')
        self.dlg = Conversion(self, "Module de conversions")
        self.dlg.Show(True)

    def onQuitter(self, evt):
        """Quitter l'application"""
        self.Destroy()

    def onAide(self, evt):
        self.dlg = Aide(self, "Aide" )
        self.dlg.Show(True)
    
    def onApropos(self, evt):
        info = wx.AboutDialogInfo()
        info.Name = "pyElec" 
        info.Version = "%s" % version
        info.Copyright = u"Logiciel distibu sous licence GPL"
        info.Description = wordwrap(
            u"pyElec permet de calculer une section de cble en fonction de :\n"
            u"- la longueur du cble\n"
            u"- l'intensit\n"
            u"- le type de conducteur\n"
            u"- la chute de tension\n"
            u"\nCe programme est un logiciel libre ; \nvous pouvez le redistribuer et/ou le modifier "
            u"au titre des clauses de la Licence Publique Gnrale GNU"
            u"; \nsoit la version 2 de la Licence, ou "
            u"une version ultrieure quelconque. \nCe programme est distribu dans l'espoir qu'il sera "
            u"utile, mais SANS AUCUNE GARANTIE ; \nsans mme une garantie implicite de COMMERCIABILITE ou "
            u"DE CONFORMITE A UNE UTILISATION PARTICULIERE. \nVoir la Licence Publique Gnrale GNU pour "
            u"plus de dtails \n(fichier \"licence.txt\")"
            u"\n\nPour tout contact, visiter le site ci-dessous",
            350, wx.ClientDC(self))
        info.WebSite = ("http://www.pycave.tuxfamily.org")
        info.Developers = [ u"Stphan GURIN | setthe@tuxfamily.org"]
        #info.License = wordwrap(licenseText, 500, wx.ClientDC(self))
        info.Licence = licenseText
        wx.AboutBox(info)    

if __name__ == "__main__":
    app = Cable()
    app.MainLoop()
